#  V486.defn.tcl

proc {Add_CAEN V486_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   for {set i 0} {$i < 8} {incr i} {
      define-vme-register $name xVME Delay$i        "-a$A32addrbase -w32 -o[expr 0x10+$i+$i] -pwo -d16 -l8 -b0 -zd"
      define-vme-register $name xVME Gate$i         "-a$A32addrbase -w32 -o[expr 0x20+$i+$i] -pwo -d16 -l8 -b0 -zd"
   }
 
   define-vme-register $name xVME Clear               "-a$A32addrbase -w32 -o0x42 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Select              "-a$A32addrbase -w32 -o0x40 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Mode                "-a$A32addrbase -w32 -o0x40 -prw -d16 -l2 -b3 -zx"
   define-vme-register $name xVME Mux                 "-a$A32addrbase -w32 -o0x40 -prw -d16 -l3 -b5 -zx"

   define-vme-register $name xVME Test                "-a$A32addrbase -w32 -o0x30 -pwo -d16 -l0 -b0 -zx"

   define-vme-register $name xVME ModID#1              "-a$A32addrbase -w32 -o0xfe -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#2              "-a$A32addrbase -w32 -o0xfc -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#3              "-a$A32addrbase -w32 -o0xfa -pro -d16 -l0 -b0 -zx"
}


proc {CAEN V486_DAQ-reset} {args} {
#   V486
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ModID#1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
    
    write-vme-register $module.Clear 0
}

proc {CAEN V486_DAQ-flush} {args} {
#   V486
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V486_DAQ-go} {args} {
#   V486
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V486_DAQ-halt} {args} {
#   V486
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V486_DAQ-setup} {args} {
#   V486
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {CAEN V486_registersavepatterns} {Delay* Gate* Select}


